<?php
class SelfTest
{
    var $appName;
    var $result;

    function SelfTest($appName)
    {
        $this->appName = $appName;
        $this->result = array();
    }

    function CheckDBConnection()
    {
        db::connect();
        $this->AddMessage("Check DB connection", mysql_error());
    }

    function CheckTables($arrTables)
    {
        db::connect();
        $errors = array ();
        foreach($arrTables as $table)
        {
            if(!$this->TableExists($table)) $errors[]="Table `".$table."` doesn't exist";
        }
        $this->AddMessage("Check DB tables", $errors);
    }

    function TableExists($table)
    {
        db::query("SELECT * FROM `".$table."`");
        return (mysql_error()) ? false : true;
    }

    function CheckFiles($files)
    {
        $files[] = "common/js/flashcoms.js";
        $files[] = "common/server/php/core/db.class.php";
        $files[] = "common/server/php/core/core.php";
        $files[] = "common/server/php/file.php";
        $files[] = "common/server/php/settings.php";
        $files[] = "flashcoms.swf";

        $errors = array ();
        foreach($files as $file)
        {
            if(!@file_exists($file)) $errors[] = "File `".$file."` doesn't exists";
        }
        if(strpos($_SERVER["SERVER_SIGNATURE"], "win") === false)
        {
            if(file_exists("files"))
            {
                if(substr(base_convert(@fileperms("files/"), 10, 8), -3) != "777")
                {
                    $errors[] = "`files/` folder permission should be set to 0777";
                }
            }
        }
        $this->AddMessage("Files", $errors);
    }

    function AddMessage($name,$error)
    {
        $this->result[$name]=$error;
    }

    function Output()
    {
        ?>
        <div style="padding:5px">
        <table width="50%" border="0" cellspacing="1" cellpadding="5" align="center" bgcolor="#D0D0D0">
        <tr bgcolor="#000000" style="background-color:#000000">
        <td colspan="2" bgcolor="#000000"><strong><?php echo $this->appName; ?> Self-Test</strong></td>
        </tr>
        <?php
        foreach($this->result as $key=>$errors)
        {
            if(is_array($errors) && sizeof($errors)>0) $error = implode('<br />',$errors);
            else if (is_string($errors) && $errors!='') $error = $errors;
            else $error = '';
            ?>
            <tr>
                <td width="40%" nowrap="nowrap" bgcolor="#000000"><?php echo $key; ?></td>
            <?php
            if ($error!='')
            {
                ?><td nowrap="nowrap" bgcolor="#FFFFFF" style="color:#FF0000"><?php echo $error; ?></td><?php
            }
            else
            {
                ?><td style="color:#009900" bgcolor="#FFFFFF">OK</td><?php
            }
            ?></tr><?php
        }
        ?>
        </table>
        </div>
        <?php
    }
}
?>
